/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pacman;

import java.awt.Color;
import java.awt.Graphics;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.util.StringTokenizer;
import javax.swing.JPanel;

/**
 *
 * @author ee462b30
 */
public class Maze extends JPanel {

    public static final int mWidth = 25;
    public static final int mHeight = 25;
    public static final int mWallDistance = 16; // 16 pixels between walls
    public static final int mBrickGap = 1;
    private boolean[][] mBrick; // true if there is a brick    
    private final Color mBackgroundColor = Color.white;
    private final Color mWallColor = Color.gray;
    private Player mPlayer; // reference, assigned at the constructor
    private Ghost mGhost[];

    public Maze(Player ply, Ghost ghs[]) {
        // default file name is maze1
        String fileName = "/home/shay/a/ee462b30/java/pacman/src/pacman/maze1";
        mPlayer = ply;
        mGhost = ghs;
        try {
            setSize(mWidth * mWallDistance, mHeight * mWallDistance);
            System.out.println("maze width = " + mWidth +
                    " maze height = " + mHeight);
            mBrick = new boolean[mWidth][mHeight];
            Reader fInput = new FileReader(fileName);
            int ghsCounter = 0;
            // read the maze
            // set the initial locations of the player and the ghosts
            for (int rowCnt = 0; rowCnt < mWidth; rowCnt++) {
                int brk;
                for (int colCnt = 0; colCnt < mHeight; colCnt++) {
                    brk = fInput.read();
                    // System.out.print((char) brk);
                    if (brk == '*') {
                        // wall
                        mBrick[rowCnt][colCnt] = true;
                    }
                    if (brk == ' ') {
                        // empty
                        mBrick[rowCnt][colCnt] = false;
                    }
                    if (brk == 'P') {
                        // player
                        ply.setLocation(colCnt, rowCnt); 
                        // notice that column is x
                        /*
                        System.out.println("Player = " +
                                rowCnt + " " + colCnt); */
                    }
                    if (brk == 'G') {
                        // ghost
                        if (ghsCounter < ghs.length) {
                            ghs[ghsCounter].setLocation(colCnt, rowCnt);
                        }
                        /*
                        System.out.println("Ghost " + ghsCounter +
                                " = " +
                                rowCnt + " " + colCnt); */
                        ghsCounter++;
                    }
                }
                brk = fInput.read();
            // remove new line at the end
            }
            fInput.close();
        } catch (IOException ioe) {
            System.out.println("IOException");
        }
    }

    public boolean collideWall(int ycoor, int xcoor) {
        if ((xcoor >= 0) && (xcoor < mWidth) &&
                (ycoor >= 0) && (ycoor < mHeight)) {
            return mBrick[ycoor][xcoor];
        }
        return true; // invalid move       
    }

    @Override
    public void paintComponent(Graphics gfx) {
        gfx.setColor(mBackgroundColor);
        gfx.fillRect(0, 0, mWidth * mWallDistance, mHeight * mWallDistance);
        gfx.setColor(mWallColor);
        for (int rowCnt = 0; rowCnt < mWidth; rowCnt++) {
            int y1 = rowCnt * mWallDistance + mBrickGap;
            for (int colCnt = 0; colCnt < mWidth; colCnt++) {
                int x1 = colCnt * mWallDistance + mBrickGap;
                if (mBrick[rowCnt][colCnt]) {
                    gfx.fillRect(x1, y1,
                            mWallDistance - mBrickGap,
                            mWallDistance - mBrickGap);
                }
            }
        }
        mPlayer.redraw(gfx);
        for (int gCounter = 0; gCounter < mGhost.length; gCounter++) {
            mGhost[gCounter].redraw(gfx);
        }
    }
}
